#ifndef _TKOL1
#define _TKOL1
#include <alloc.h>
#include <string.h>
#include <iostream.h>
#include <conio.h>
template <class T>
class TKol1
	 { public:
		T **elem;  //elem jako wskaznik dla dynamicznej tablicy wskaznikow T*
		int ile;
		TKol1() {elem=NULL; ile = 0;}
	 ~TKol1(){};

	 int Pusty(T** p)  {return p == NULL;}

	int Zmien(int delta)
	 { T** pom;
			pom = (T**)realloc(elem,sizeof(T*)*(ile+delta));
		 if (pom)
			elem=pom;
			return !Pusty(pom);
	 }

	int Zakres(int ktory)
	{ return ktory>=0 && ktory<ile;}

	int Wstaw(T* dane, int ktory)
	 {
		 if (ktory <0 || ktory>ile) return 0;
		 memmove( &elem[ktory+1], &elem[ktory], (ile-ktory)*sizeof(void *) );
		 elem[ktory]=dane;
		 ile++;
		 return 1;
		}

	 int Usun(int ktory)
		{
		 if (!Zakres(ktory)) return 0;
		 delete(elem[ktory]);
		 ile--;
		 memmove( &elem[ktory], &elem[ktory+1], (ile-ktory)*sizeof(void *) );
		 return 1;
		}

	 void _Usun(int ktory)
		{
		 Usun(ktory);
		 if (ile==0) Usun_kolekcje();
		 else	Zmien(0);
		}
	 void Usun_kolekcje();
	 friend ostream& operator<<(ostream&,const TKol1<T>&);
	 virtual T* Szukaj(int (*)(T*,void*),int &,void*);
};

	template <class T>
		T* TKol1<T>::Szukaj(int (*p)(T*,void*),int& ktory, void* b)
		{ int pom=1;
			ktory=ile;
			while(ktory>0 && pom!=0)
				pom=p(elem[--ktory],b);
			if (pom==0)
			 return elem[ktory];
			return NULL;
		}

 template <class T>
	void TKol1<T>::Usun_kolekcje()
	 {
		int i=ile;
		while(i>0) delete elem[--i];
		delete []elem;
		elem=NULL;
		ile=0;
	 }

 template <class T>
 ostream& operator<<(ostream& a,const TKol1<T>& k)
	{  int i=0;
			while(i<k.ile)
			{a<<*(k.elem[i++]);getch();}
			return a;}
#endif
